var docData = {"isSingleFile":false,"name":"docker","description":"\u003ch2\u003eModule Overview\u003c/h2\u003e\n\u003cp\u003eThis module offers an annotation based docker extension implementation for Ballerina.\u003c/p\u003e\n\u003cul\u003e\n\u003cli\u003eFor information on the operations, which you can perform with this module, see \u003ca href\u003d\"/swan-lake/learn/api-docs/ballerina/docker/index.html#records\"\u003eRecords\u003c/a\u003e.\u003c/li\u003e\n\u003cli\u003eFor information on the deploymenr, see the \u003ca href\u003d\"/swan-lake/learn/deployment/docker/\"\u003eDocker Deployemnt Guide\u003c/a\u003e.\u003c/li\u003e\n\u003cli\u003eFor examples on the usage of the operations, see the \u003ca href\u003d\"/swan-lake/learn/by-example/docker-deployment.html\"\u003eDocker Deployment Example\u003c/a\u003e.\u003c/li\u003e\n\u003c/ul\u003e\n\u003ch3\u003eAnnotation Usage Sample:\u003c/h3\u003e\n\u003cpre\u003e\u003ccode class\u003d\"language-ballerina\"\u003eimport ballerina/http;\nimport ballerina/log;\nimport ballerina/docker;\n\n@docker:Expose{}\nlistener http:Listener helloWorldEP \u003d new(9090);\n\n@http:ServiceConfig {\n      basePath: \u0026quot;/helloWorld\u0026quot;\n}\n@docker:Config {\n    registry: \u0026quot;docker.abc.com\u0026quot;,\n    name: \u0026quot;helloworld\u0026quot;,\n    tag: \u0026quot;v1.0\u0026quot;\n}\nservice helloWorld on helloWorldEP {\n    resource function sayHello(http:Caller caller, http:Request request) {\n        http:Response response \u003d new;\n        response.setTextPayload(\u0026quot;Hello, World from service helloWorld ! \\n\u0026quot;);\n        var responseResult \u003d caller-\u0026gt;respond(response);\n        if (responseResult is error) {\n            log:printError(\u0026quot;error responding back to client.\u0026quot;, err \u003d responseResult);\n        }\n    }\n}\n\u003c/code\u003e\u003c/pre\u003e\n","modules":[{"id":"docker","summary":"\u003cp\u003eThis module offers an annotation based docker extension implementation for Ballerina.\u003c/p\u003e\n","description":"\u003ch2\u003eModule Overview\u003c/h2\u003e\n\u003cp\u003eThis module offers an annotation based docker extension implementation for Ballerina.\u003c/p\u003e\n\u003cul\u003e\n\u003cli\u003eFor information on the operations, which you can perform with this module, see \u003ca href\u003d\"/swan-lake/learn/api-docs/ballerina/docker/index.html#records\"\u003eRecords\u003c/a\u003e.\u003c/li\u003e\n\u003cli\u003eFor information on the deploymenr, see the \u003ca href\u003d\"/swan-lake/learn/deployment/docker/\"\u003eDocker Deployemnt Guide\u003c/a\u003e.\u003c/li\u003e\n\u003cli\u003eFor examples on the usage of the operations, see the \u003ca href\u003d\"/swan-lake/learn/by-example/docker-deployment.html\"\u003eDocker Deployment Example\u003c/a\u003e.\u003c/li\u003e\n\u003c/ul\u003e\n\u003ch3\u003eAnnotation Usage Sample:\u003c/h3\u003e\n\u003cpre\u003e\u003ccode class\u003d\"language-ballerina\"\u003eimport ballerina/http;\nimport ballerina/log;\nimport ballerina/docker;\n\n@docker:Expose{}\nlistener http:Listener helloWorldEP \u003d new(9090);\n\n@http:ServiceConfig {\n      basePath: \u0026quot;/helloWorld\u0026quot;\n}\n@docker:Config {\n    registry: \u0026quot;docker.abc.com\u0026quot;,\n    name: \u0026quot;helloworld\u0026quot;,\n    tag: \u0026quot;v1.0\u0026quot;\n}\nservice helloWorld on helloWorldEP {\n    resource function sayHello(http:Caller caller, http:Request request) {\n        http:Response response \u003d new;\n        response.setTextPayload(\u0026quot;Hello, World from service helloWorld ! \\n\u0026quot;);\n        var responseResult \u003d caller-\u0026gt;respond(response);\n        if (responseResult is error) {\n            log:printError(\u0026quot;error responding back to client.\u0026quot;, err \u003d responseResult);\n        }\n    }\n}\n\u003c/code\u003e\u003c/pre\u003e\n","orgName":"ballerina","version":"1.0.0","records":[{"fields":[{"defaultValue":"","type":{"name":"string","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},"name":"registry","description":"\u003cp\u003eDocker registry url.\u003c/p\u003e\n","isDeprecated":false},{"defaultValue":"","type":{"name":"string","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},"name":"name","description":"\u003cp\u003eName of the docker image. Default value is the file name of the executable .jar file.\u003c/p\u003e\n","isDeprecated":false},{"defaultValue":"","type":{"name":"string","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},"name":"tag","description":"\u003cp\u003eDocker image tag. Default value is \u003ccode\u003e\u0026quot;latest\u0026quot;\u003c/code\u003e.\u003c/p\u003e\n","isDeprecated":false},{"defaultValue":"","type":{"name":"string","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},"name":"username","description":"\u003cp\u003eUsername for docker registry.\u003c/p\u003e\n","isDeprecated":false},{"defaultValue":"","type":{"name":"string","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},"name":"password","description":"\u003cp\u003ePassword for docker registry.\u003c/p\u003e\n","isDeprecated":false},{"defaultValue":"","type":{"name":"string","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},"name":"baseImage","description":"\u003cp\u003eBase image to create the docker image. Default value is \u003ccode\u003e\u0026quot;ballerina/jre8:v1\u0026quot;\u003c/code\u003e.\u003c/p\u003e\n","isDeprecated":false},{"defaultValue":"true","type":{"name":"boolean","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},"name":"buildImage","description":"\u003cp\u003eEnable building docker image. Default value is \u003ccode\u003etrue\u003c/code\u003e.\u003c/p\u003e\n","isDeprecated":false},{"defaultValue":"false","type":{"name":"boolean","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},"name":"push","description":"\u003cp\u003eEnable pushing docker image to registry. Field \u003ccode\u003ebuildImage\u003c/code\u003e must be set to \u003ccode\u003etrue\u003c/code\u003e to be effective. Default value is \u003ccode\u003efalse\u003c/code\u003e.\u003c/p\u003e\n","isDeprecated":false},{"defaultValue":"","type":{"name":"string","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},"name":"cmd","description":"\u003cp\u003eValue for CMD for the generated Dockerfile. Default is \u003ccode\u003eCMD java -jar ${APP} [--b7a.config.file\u003d${CONFIG_FILE}] [--debug]\u003c/code\u003e.\u003c/p\u003e\n","isDeprecated":false},{"defaultValue":"false","type":{"name":"boolean","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},"name":"enableDebug","description":"\u003cp\u003eEnable ballerina debug. Default is \u003ccode\u003efalse\u003c/code\u003e.\u003c/p\u003e\n","isDeprecated":false},{"defaultValue":"5005","type":{"name":"int","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},"name":"debugPort","description":"\u003cp\u003eBallerina remote debug port. Default is \u003ccode\u003e5005\u003c/code\u003e.\u003c/p\u003e\n","isDeprecated":false},{"defaultValue":"","type":{"name":"string","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},"name":"dockerAPIVersion","description":"\u003cp\u003eDocker API version.\u003c/p\u003e\n","isDeprecated":false},{"defaultValue":"","type":{"name":"string","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},"name":"dockerHost","description":"\u003cp\u003eDocker host IP and docker PORT. (e.g minikube IP and docker PORT).\nDefault is to use DOCKER_HOST environment variable.\nIf DOCKER_HOST is unavailable, use \u003ccode\u003e\u0026quot;unix:///var/run/docker.sock\u0026quot;\u003c/code\u003e for Unix or use \u003ccode\u003e\u0026quot;tcp://localhost:2375\u0026quot;\u003c/code\u003e for Windows.\u003c/p\u003e\n","isDeprecated":false},{"defaultValue":"","type":{"name":"string","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},"name":"dockerCertPath","description":"\u003cp\u003eDocker certificate path. Default is to use \u003ccode\u003e\u0026quot;DOCKER_CERT_PATH\u0026quot;\u003c/code\u003e environment variable.\u003c/p\u003e\n","isDeprecated":false},{"defaultValue":"","type":{"name":"map","category":"map","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0,"constraint":{"isAnonymousUnionType":true,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[{"name":"boolean","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},{"name":"int","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},{"name":"float","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},{"name":"decimal","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},{"name":"string","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0}],"paramTypes":[],"arrayDimensions":0}},"name":"env","description":"\u003cp\u003eEnvironment variables for container.\u003c/p\u003e\n","isDeprecated":false},{"defaultValue":"","type":{"name":"string","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},"name":"dockerConfigPath","description":"\u003cp\u003eDocker config file path.\u003c/p\u003e\n","isDeprecated":false},{"defaultValue":"","type":{"name":"boolean","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},"name":"uberJar","description":"\u003cp\u003eUse ballerina uber jar. Default is \u003ccode\u003efalse\u003c/code\u003e.\u003c/p\u003e\n","isDeprecated":false}],"isClosed":true,"name":"DockerConfiguration","description":"\u003cp\u003eDocker annotation configuration.\u003c/p\u003e\n","isDeprecated":false},{"fields":[{"defaultValue":"","type":{"name":"string","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},"name":"sourceFile","description":"\u003cp\u003eSource path of the file (in your machine).\u003c/p\u003e\n","isDeprecated":false},{"defaultValue":"","type":{"name":"string","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},"name":"target","description":"\u003cp\u003eTarget path (inside container).\u003c/p\u003e\n","isDeprecated":false},{"defaultValue":"false","type":{"name":"boolean","category":"builtin","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},"name":"isBallerinaConf","description":"\u003cp\u003eFlag to specify ballerina config file. When true, the config is passed as a command argument to the Dockerfile CMD.\u003c/p\u003e\n","isDeprecated":false}],"isClosed":true,"name":"FileConfig","description":"\u003cp\u003eExternal file type for docker.\u003c/p\u003e\n","isDeprecated":false},{"fields":[{"defaultValue":"","type":{"isAnonymousUnionType":false,"isArrayType":true,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":1,"elementType":{"moduleName":"docker","name":"FileConfig","category":"records","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0}},"name":"files","description":"\u003cp\u003eArray of file configurations.\u003c/p\u003e\n","isDeprecated":false}],"isClosed":true,"name":"FileConfigs","description":"\u003cp\u003eExternal File configurations for docker.\u003c/p\u003e\n","isDeprecated":false},{"fields":[],"isClosed":true,"name":"ExposeConfig","description":"\u003cp\u003eExpose ports for docker.\u003c/p\u003e\n","isDeprecated":false}],"classes":[],"abstractObjects":[],"clients":[],"listeners":[],"functions":[],"constants":[],"annotations":[{"type":{"moduleName":"docker","name":"DockerConfiguration","category":"records","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},"attachmentPoints":"source service, source listener, source function","name":"Config","description":"\u003cp\u003e@docker:Config annotation to configure docker artifact generation.\u003c/p\u003e\n","isDeprecated":false},{"type":{"moduleName":"docker","name":"FileConfigs","category":"records","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},"attachmentPoints":"source service, source listener, source function","name":"CopyFiles","description":"\u003cp\u003e@docker:CopyFile annotation to copy external files to docker image.\u003c/p\u003e\n","isDeprecated":false},{"type":{"moduleName":"docker","name":"ExposeConfig","category":"records","isAnonymousUnionType":false,"isArrayType":false,"isNullable":false,"isTuple":false,"isIntersectionType":false,"isParenthesisedType":false,"isRestParam":false,"isLambda":false,"isDeprecated":false,"generateUserDefinedTypeLink":true,"memberTypes":[],"paramTypes":[],"arrayDimensions":0},"attachmentPoints":"source listener","name":"Expose","description":"\u003cp\u003e@docker:Expose annotation to expose ballerina ports.\u003c/p\u003e\n","isDeprecated":false}],"errors":[],"types":[],"resources":[]}]};